GNU bug report logs - #13479
Cross Compiling for ARM

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: emacs; Reported by: Ross Biro <ross.biro@HIDDEN>; merged with #9192; dated Thu, 17 Jan 2013 20:03:02 UTC; Maintainer for emacs is bug-gnu-emacs@HIDDEN.
Forcibly Merged 9192 13479. Request was from Glenn Morris <rgm@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at 13479 <at> debbugs.gnu.org:


Received: (at 13479) by debbugs.gnu.org; 24 Jan 2013 04:42:50 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Jan 23 23:42:50 2013
Received: from localhost ([127.0.0.1]:47155 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1TyEeG-00060u-GA
	for submit <at> debbugs.gnu.org; Wed, 23 Jan 2013 23:42:49 -0500
Received: from mail-pa0-f49.google.com ([209.85.220.49]:32984)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <jasonrumney@HIDDEN>) id 1TyEeD-00060i-Jy
	for 13479 <at> debbugs.gnu.org; Wed, 23 Jan 2013 23:42:46 -0500
Received: by mail-pa0-f49.google.com with SMTP id bi1so5229850pad.8
	for <13479 <at> debbugs.gnu.org>; Wed, 23 Jan 2013 20:42:44 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113;
	h=x-received:sender:from:to:cc:subject:references:date:in-reply-to
	:message-id:user-agent:mime-version:content-type;
	bh=t9dePx0sWeNCPPcFVHKhkwlXv/dj81evUO9Ms8khIB8=;
	b=Op1vF5XUD04suLjQ9GQfNBQDbj43iRKnEtkybwmLwY3hvKwrQW2hskI+HbZ+x5cjjy
	BWNN7Ige+YRgCKc/XF3pdxKl32hFvl2EG7ENuwmTwHpNfaRpYgJc6ohkMLKN38KIkF5C
	FKnpzxf3wbc16GkkbzC7P7ePCyOytH+gg5oRdXXx4PI0zgcA53JSY5DHTfHsxbyAm9fX
	6xuu4b+zbD91PhxB1Q6T6k8VqBlYQOewEbO2eO8G0quFcoec4fSozH5a1TerITruX+xd
	nyfi71fqKpzMFo0YCB9aq4w/iTTdw6XxPf1fbwudiCWORgHJfTsdowB8rdgzDmNRudpT
	IyIA==
X-Received: by 10.66.72.201 with SMTP id f9mr1576926pav.38.1359002564217;
	Wed, 23 Jan 2013 20:42:44 -0800 (PST)
Received: from home.jasonrumney.net ([180.75.201.177])
	by mx.google.com with ESMTPS id na7sm14090618pbc.48.2013.01.23.20.42.34
	(version=TLSv1.1 cipher=ECDHE-RSA-RC4-SHA bits=128/128);
	Wed, 23 Jan 2013 20:42:42 -0800 (PST)
Received: by home.jasonrumney.net (Postfix, from userid 1000)
	id 4DF0355E; Thu, 24 Jan 2013 12:42:26 +0800 (MYT)
From: Jason Rumney <jasonr@HIDDEN>
To: Stefan Monnier <monnier@HIDDEN>
Subject: Re: bug#13479: Cross Compiling for ARM
References: <CAJ56fyho5sZoR2w15_h2KceCcqHf1=6-G=ocSQELCHS_2yF2dw@HIDDEN>
	<jwvsj5z9qph.fsf-monnier+emacs@HIDDEN>
Date: Thu, 24 Jan 2013 12:42:26 +0800
In-Reply-To: <jwvsj5z9qph.fsf-monnier+emacs@HIDDEN> (Stefan Monnier's message
	of "Fri, 18 Jan 2013 09:26:49 -0500")
Message-ID: <87obgfw5sd.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.3.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 13479
Cc: Ross Biro <ross.biro@HIDDEN>, 13479 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -2.6 (--)

Stefan Monnier <monnier@HIDDEN> writes:

>> Obviously, I also had to CANNOT_DUMP=yes as well.
>
> That's a problem that would need to be solved, of course, because there
> are invariably more bugs in this mode of operation.
>
>> 1) ... However make-docfile and test-distrib need to be built with
>> the local compiler...
>
> We could incorporate this part of your changes, I think.
>
>> 2) The lisp and leim directories really want a local copy of Emacs to
>> compile.
>
> ...
> An alternative is of course to use an emulator to run src/emacs and/or
> src/bootstrap-emacs.

Using an emulator would allow dumping as well, and could also be used
for make-docfile and test-distrib.

I think gcc has similar cross-compilation bootstrapping issues which
have been solved in the makefiles, so that is probably a good example to
follow if making cross-compilation work is something someone wants to
seriously fix.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#13479; Package emacs. Full text available.

Message received at 13479 <at> debbugs.gnu.org:


Received: (at 13479) by debbugs.gnu.org; 23 Jan 2013 07:32:45 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Jan 23 02:32:45 2013
Received: from localhost ([127.0.0.1]:45517 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1TxupA-0007vm-Mp
	for submit <at> debbugs.gnu.org; Wed, 23 Jan 2013 02:32:45 -0500
Received: from mout.gmx.net ([212.227.15.19]:59597)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <rudalics@HIDDEN>) id 1Txup7-0007vZ-3C
	for 13479 <at> debbugs.gnu.org; Wed, 23 Jan 2013 02:32:42 -0500
Received: from mailout-de.gmx.net ([10.1.76.2]) by mrigmx.server.lan
	(mrigmx002) with ESMTP (Nemesis) id 0M7FLk-1T0zMZ3d5S-00x284 for
	<13479 <at> debbugs.gnu.org>; Wed, 23 Jan 2013 08:31:25 +0100
Received: (qmail invoked by alias); 23 Jan 2013 07:31:25 -0000
Received: from 62-47-40-128.adsl.highway.telekom.at (EHLO [62.47.40.128])
	[62.47.40.128]
	by mail.gmx.net (mp002) with SMTP; 23 Jan 2013 08:31:25 +0100
X-Authenticated: #14592706
X-Provags-ID: V01U2FsdGVkX1/he7BM0MnhS3aS/8Vd9M8hYHCfDHAFa904xBP1Fv
	t1jgLn7AApLyCe
Message-ID: <50FF91CC.4020404@HIDDEN>
Date: Wed, 23 Jan 2013 08:31:24 +0100
From: martin rudalics <rudalics@HIDDEN>
MIME-Version: 1.0
To: Ross Biro <ross.biro@HIDDEN>
Subject: Re: bug#13479: Cross Compiling for ARM
References: <CAJ56fyho5sZoR2w15_h2KceCcqHf1=6-G=ocSQELCHS_2yF2dw@HIDDEN>	<jwvsj5z9qph.fsf-monnier+emacs@HIDDEN>	<50F98C7B.8090708@HIDDEN>	<CAJ56fyiL62MtXUqD5PygCF3KUs-kJ5vmQ7S8bcBvn=fq21uMXg@HIDDEN>	<50FA7153.403@HIDDEN>
	<CAJ56fyi6i_ws3Cu877CAqH-eUAy3Tepx21Bz1_mOWub0RMVS8A@HIDDEN>
In-Reply-To: <CAJ56fyi6i_ws3Cu877CAqH-eUAy3Tepx21Bz1_mOWub0RMVS8A@HIDDEN>
Content-Type: multipart/mixed; boundary="------------020209070507090100000106"
X-Y-GMX-Trusted: 0
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 13479
Cc: Stefan Monnier <monnier@HIDDEN>, 13479 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -1.9 (-)

This is a multi-part message in MIME format.
--------------020209070507090100000106
Content-Type: text/plain; charset=ISO-8859-1; format=flowed
Content-Transfer-Encoding: 7bit

 > I don't have a wset_new_total.  Is that a new function?  I'm using mostly
 > stock 24.2.

These are setter functions whose purpose I forgot.  I attach a manually
and untested reconstruction of the original assignments.

martin

--------------020209070507090100000106
Content-Type: text/plain;
 name="resize_root_window_vertically.diff"
Content-Transfer-Encoding: 7bit
Content-Disposition: inline;
 filename="resize_root_window_vertically.diff"

=== modified file 'src/window.c'
--- src/window.c	2013-01-11 23:08:55 +0000
+++ src/window.c	2013-01-19 09:54:07 +0000
@@ -4207,8 +4207,15 @@
 
   root = FRAME_ROOT_WINDOW (f);
   r = XWINDOW (root);
-  value = call2 (Qwindow_resize_root_window_vertically,
-		 root, make_number (- delta));
+  if (WINDOW_LIVE_P (root))
+    {
+      r->new_total = make_number (XFASTINT (r->total_lines) - delta);
+      value = make_number (- delta);
+    }
+  else
+    value = call2 (Qwindow_resize_root_window_vertically,
+		   root, make_number (- delta));
+
   if (INTEGERP (value) && window_resize_check (r, 0))
     {
       block_input ();
@@ -4245,8 +4252,15 @@
     {
       root = FRAME_ROOT_WINDOW (f);
       r = XWINDOW (root);
-      value = call2 (Qwindow_resize_root_window_vertically,
-		     root, make_number (size - 1));
+      if (WINDOW_LIVE_P (root))
+	{
+	  r->new_total = make_number (XFASTINT (r->total_lines) + size - 1);
+	  value = make_number (size - 1);
+	}
+      else
+	value = call2 (Qwindow_resize_root_window_vertically,
+		       root, make_number (size - 1));
+
       if (INTEGERP (value) && window_resize_check (r, 0))
 	{
 	  block_input ();



--------------020209070507090100000106--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#13479; Package emacs. Full text available.

Message received at 13479 <at> debbugs.gnu.org:


Received: (at 13479) by debbugs.gnu.org; 23 Jan 2013 03:50:36 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Jan 22 22:50:36 2013
Received: from localhost ([127.0.0.1]:45378 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1TxrMC-00088R-56
	for submit <at> debbugs.gnu.org; Tue, 22 Jan 2013 22:50:36 -0500
Received: from mail-lb0-f174.google.com ([209.85.217.174]:41953)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <ross.biro@HIDDEN>) id 1TxrM2-000882-IV
	for 13479 <at> debbugs.gnu.org; Tue, 22 Jan 2013 22:50:35 -0500
Received: by mail-lb0-f174.google.com with SMTP id l12so1319555lbo.19
	for <13479 <at> debbugs.gnu.org>; Tue, 22 Jan 2013 19:49:12 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113;
	h=mime-version:x-received:sender:in-reply-to:references:date
	:x-google-sender-auth:message-id:subject:from:to:cc:content-type;
	bh=uYKxOqdqudN3FYxDSLE9Nz1f4bhKJfoUvydP18IHtBg=;
	b=xLmLbKkz0+xS7B/Qs31ONAdB1kdZdV/nWdqLvjARgBuLwa+PmP/7YjvGnmttL5t3+M
	hqnax9cFUpqB5UXG8OSuVIXWRL5fbrt03pkzsTAjVz5lA+DgvTQ5POTYfyOBXco/lKXR
	HOCu5nI7UyaUN98CITvs6VtVCi9wsoodNcHIlMYj7/EZGKlXUVcgPQdXZ5DPqXuOQmYj
	K5waUGngpM3JZeK7yUquPNFNwbwajDdPgYKZ3nqVZoqRzFWhA9krYCpmnMVN9GROmKTD
	Ju4+LyTuNCqe3vLZS9RsrmSDENGlE0DQis4pQIpFgcA+Ok7l0hdqkiNs9ZqdcSsO679s
	BNKQ==
MIME-Version: 1.0
X-Received: by 10.112.44.134 with SMTP id e6mr77993lbm.134.1358912952852; Tue,
	22 Jan 2013 19:49:12 -0800 (PST)
Received: by 10.152.11.169 with HTTP; Tue, 22 Jan 2013 19:49:12 -0800 (PST)
In-Reply-To: <50FA7153.403@HIDDEN>
References: <CAJ56fyho5sZoR2w15_h2KceCcqHf1=6-G=ocSQELCHS_2yF2dw@HIDDEN>
	<jwvsj5z9qph.fsf-monnier+emacs@HIDDEN> <50F98C7B.8090708@HIDDEN>
	<CAJ56fyiL62MtXUqD5PygCF3KUs-kJ5vmQ7S8bcBvn=fq21uMXg@HIDDEN>
	<50FA7153.403@HIDDEN>
Date: Tue, 22 Jan 2013 22:49:12 -0500
X-Google-Sender-Auth: JUjZX_L_IZUB7BBt9kzALloWNbc
Message-ID: <CAJ56fyi6i_ws3Cu877CAqH-eUAy3Tepx21Bz1_mOWub0RMVS8A@HIDDEN>
Subject: Re: bug#13479: Cross Compiling for ARM
From: Ross Biro <ross.biro@HIDDEN>
To: martin rudalics <rudalics@HIDDEN>
Content-Type: multipart/alternative; boundary=bcaec554d29ad5e0b404d3ec93ea
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 13479
Cc: Stefan Monnier <monnier@HIDDEN>, 13479 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -2.6 (--)

--bcaec554d29ad5e0b404d3ec93ea
Content-Type: text/plain; charset=ISO-8859-1

I don't have a wset_new_total.  Is that a new function?  I'm using mostly
stock 24.2.

    Ross


On Sat, Jan 19, 2013 at 5:11 AM, martin rudalics <rudalics@HIDDEN> wrote:

> I haven't investigated.  But because protecting those calls by if
>> (initialized) and even moving the lisp->C binding for
>> window_root_window_resize_**vertically to after initialization didn't
>> help, I
>> suspect the issue might be deeper than just protecting C calls to lisp.  I
>> really don't know how to follow up though.
>>
>
> If Lisp hasn't been called yet, the root window cannot have
> been split yet.  So in the case at hand the following patch
> sould work.  Can you please try it?
>
> Thanks, martin
>
>
> === modified file 'src/window.c'
> --- src/window.c        2013-01-11 23:08:55 +0000
> +++ src/window.c        2013-01-19 09:54:07 +0000
> @@ -4207,8 +4207,15 @@
>
>    root = FRAME_ROOT_WINDOW (f);
>    r = XWINDOW (root);
> -  value = call2 (Qwindow_resize_root_window_vertically,
> -                root, make_number (- delta));
> +  if (WINDOW_LIVE_P (root))
> +    {
> +      wset_new_total (r, make_number (XFASTINT (r->total_lines) - delta));
> +      value = make_number (- delta);
> +    }
> +  else
> +    value = call2 (Qwindow_resize_root_window_vertically,
> +                  root, make_number (- delta));
> +
>    if (INTEGERP (value) && window_resize_check (r, 0))
>      {
>        block_input ();
> @@ -4245,8 +4252,15 @@
>      {
>        root = FRAME_ROOT_WINDOW (f);
>        r = XWINDOW (root);
> -      value = call2 (Qwindow_resize_root_window_vertically,
> -                    root, make_number (size - 1));
> +      if (WINDOW_LIVE_P (root))
> +       {
> +         wset_new_total (r, make_number (XFASTINT (r->total_lines) + size
> - 1));
> +         value = make_number (size - 1);
> +       }
> +      else
> +       value = call2 (Qwindow_resize_root_window_vertically,
> +                      root, make_number (size - 1));
> +
>        if (INTEGERP (value) && window_resize_check (r, 0))
>         {
>           block_input ();
>
>
>
>

--bcaec554d29ad5e0b404d3ec93ea
Content-Type: text/html; charset=ISO-8859-1
Content-Transfer-Encoding: quoted-printable

<div dir=3D"ltr"><div>I don&#39;t have a wset_new_total.=A0 Is that a new f=
unction?=A0 I&#39;m using mostly stock 24.2.<br><br></div>=A0=A0=A0 Ross<br=
></div><div class=3D"gmail_extra"><br><br><div class=3D"gmail_quote">On Sat=
, Jan 19, 2013 at 5:11 AM, martin rudalics <span dir=3D"ltr">&lt;<a href=3D=
"mailto:rudalics@HIDDEN" target=3D"_blank">rudalics@HIDDEN</a>&gt;</span> w=
rote:<br>
<blockquote class=3D"gmail_quote" style=3D"margin:0 0 0 .8ex;border-left:1p=
x #ccc solid;padding-left:1ex"><div class=3D"im"><blockquote class=3D"gmail=
_quote" style=3D"margin:0 0 0 .8ex;border-left:1px #ccc solid;padding-left:=
1ex">
I haven&#39;t investigated. =A0But because protecting those calls by if<br>
(initialized) and even moving the lisp-&gt;C binding for<br>
window_root_window_resize_<u></u>vertically to after initialization didn&#3=
9;t help, I<br>
suspect the issue might be deeper than just protecting C calls to lisp. =A0=
I<br>
really don&#39;t know how to follow up though.<br>
</blockquote>
<br></div>
If Lisp hasn&#39;t been called yet, the root window cannot have<br>
been split yet. =A0So in the case at hand the following patch<br>
sould work. =A0Can you please try it?<br>
<br>
Thanks, martin<br>
<br>
<br>=3D=3D=3D modified file &#39;src/window.c&#39;<br>
--- src/window.c =A0 =A0 =A0 =A02013-01-11 23:08:55 +0000<br>
+++ src/window.c =A0 =A0 =A0 =A02013-01-19 09:54:07 +0000<br>
@@ -4207,8 +4207,15 @@<br>
<br>
=A0 =A0root =3D FRAME_ROOT_WINDOW (f);<br>
=A0 =A0r =3D XWINDOW (root);<br>
- =A0value =3D call2 (Qwindow_resize_root_window_vertically,<br>
- =A0 =A0 =A0 =A0 =A0 =A0 =A0 =A0root, make_number (- delta));<br>
+ =A0if (WINDOW_LIVE_P (root))<br>
+ =A0 =A0{<br>
+ =A0 =A0 =A0wset_new_total (r, make_number (XFASTINT (r-&gt;total_lines) -=
 delta));<br>
+ =A0 =A0 =A0value =3D make_number (- delta);<br>
+ =A0 =A0}<br>
+ =A0else<br>
+ =A0 =A0value =3D call2 (Qwindow_resize_root_window_vertically,<br>
+ =A0 =A0 =A0 =A0 =A0 =A0 =A0 =A0 =A0root, make_number (- delta));<br>
+<br>
=A0 =A0if (INTEGERP (value) &amp;&amp; window_resize_check (r, 0))<br>
=A0 =A0 =A0{<br>
=A0 =A0 =A0 =A0block_input ();<br>
@@ -4245,8 +4252,15 @@<br>
=A0 =A0 =A0{<br>
=A0 =A0 =A0 =A0root =3D FRAME_ROOT_WINDOW (f);<br>
=A0 =A0 =A0 =A0r =3D XWINDOW (root);<br>
- =A0 =A0 =A0value =3D call2 (Qwindow_resize_root_window_vertically,<br>
- =A0 =A0 =A0 =A0 =A0 =A0 =A0 =A0 =A0 =A0root, make_number (size - 1));<br>
+ =A0 =A0 =A0if (WINDOW_LIVE_P (root))<br>
+ =A0 =A0 =A0 {<br>
+ =A0 =A0 =A0 =A0 wset_new_total (r, make_number (XFASTINT (r-&gt;total_lin=
es) + size - 1));<br>
+ =A0 =A0 =A0 =A0 value =3D make_number (size - 1);<br>
+ =A0 =A0 =A0 }<br>
+ =A0 =A0 =A0else<br>
+ =A0 =A0 =A0 value =3D call2 (Qwindow_resize_root_window_vertically,<br>
+ =A0 =A0 =A0 =A0 =A0 =A0 =A0 =A0 =A0 =A0 =A0root, make_number (size - 1));=
<br>
+<br>
=A0 =A0 =A0 =A0if (INTEGERP (value) &amp;&amp; window_resize_check (r, 0))<=
br>
=A0 =A0 =A0 =A0 {<br>
=A0 =A0 =A0 =A0 =A0 block_input ();<br>
<br>
<br>
<br></blockquote></div><br></div>

--bcaec554d29ad5e0b404d3ec93ea--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#13479; Package emacs. Full text available.

Message received at 13479 <at> debbugs.gnu.org:


Received: (at 13479) by debbugs.gnu.org; 19 Jan 2013 10:12:32 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jan 19 05:12:32 2013
Received: from localhost ([127.0.0.1]:39559 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1TwVPc-00007X-2f
	for submit <at> debbugs.gnu.org; Sat, 19 Jan 2013 05:12:32 -0500
Received: from mout.gmx.net ([212.227.17.20]:50258)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <rudalics@HIDDEN>) id 1TwVPZ-00007Q-Lr
	for 13479 <at> debbugs.gnu.org; Sat, 19 Jan 2013 05:12:30 -0500
Received: from mailout-de.gmx.net ([10.1.76.1]) by mrigmx.server.lan
	(mrigmx001) with ESMTP (Nemesis) id 0M21p7-1T3JRa0rSl-00u0pb for
	<13479 <at> debbugs.gnu.org>; Sat, 19 Jan 2013 11:11:37 +0100
Received: (qmail invoked by alias); 19 Jan 2013 10:11:37 -0000
Received: from 62-47-47-149.adsl.highway.telekom.at (EHLO [62.47.47.149])
	[62.47.47.149]
	by mail.gmx.net (mp001) with SMTP; 19 Jan 2013 11:11:37 +0100
X-Authenticated: #14592706
X-Provags-ID: V01U2FsdGVkX1/IWxxQzKfIq9IvbYelOcJWUmhRRWu3Va5Nx+R8kF
	h1IIvr7VSFWSzn
Message-ID: <50FA7153.403@HIDDEN>
Date: Sat, 19 Jan 2013 11:11:31 +0100
From: martin rudalics <rudalics@HIDDEN>
MIME-Version: 1.0
To: Ross Biro <ross.biro@HIDDEN>
Subject: Re: bug#13479: Cross Compiling for ARM
References: <CAJ56fyho5sZoR2w15_h2KceCcqHf1=6-G=ocSQELCHS_2yF2dw@HIDDEN>	<jwvsj5z9qph.fsf-monnier+emacs@HIDDEN>	<50F98C7B.8090708@HIDDEN>
	<CAJ56fyiL62MtXUqD5PygCF3KUs-kJ5vmQ7S8bcBvn=fq21uMXg@HIDDEN>
In-Reply-To: <CAJ56fyiL62MtXUqD5PygCF3KUs-kJ5vmQ7S8bcBvn=fq21uMXg@HIDDEN>
Content-Type: multipart/mixed; boundary="------------080307080307070907060905"
X-Y-GMX-Trusted: 0
X-Spam-Score: 0.8 (/)
X-Debbugs-Envelope-To: 13479
Cc: Stefan Monnier <monnier@HIDDEN>, 13479 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -1.9 (-)

This is a multi-part message in MIME format.
--------------080307080307070907060905
Content-Type: text/plain; charset=ISO-8859-1; format=flowed
Content-Transfer-Encoding: 7bit

> I haven't investigated.  But because protecting those calls by if
> (initialized) and even moving the lisp->C binding for
> window_root_window_resize_vertically to after initialization didn't help, I
> suspect the issue might be deeper than just protecting C calls to lisp.  I
> really don't know how to follow up though.

If Lisp hasn't been called yet, the root window cannot have
been split yet.  So in the case at hand the following patch
sould work.  Can you please try it?

Thanks, martin


--------------080307080307070907060905
Content-Type: text/plain;
 name="resize_root_window_vertically.diff"
Content-Transfer-Encoding: 7bit
Content-Disposition: inline;
 filename="resize_root_window_vertically.diff"

=== modified file 'src/window.c'
--- src/window.c	2013-01-11 23:08:55 +0000
+++ src/window.c	2013-01-19 09:54:07 +0000
@@ -4207,8 +4207,15 @@
 
   root = FRAME_ROOT_WINDOW (f);
   r = XWINDOW (root);
-  value = call2 (Qwindow_resize_root_window_vertically,
-		 root, make_number (- delta));
+  if (WINDOW_LIVE_P (root))
+    {
+      wset_new_total (r, make_number (XFASTINT (r->total_lines) - delta));
+      value = make_number (- delta);
+    }
+  else
+    value = call2 (Qwindow_resize_root_window_vertically,
+		   root, make_number (- delta));
+
   if (INTEGERP (value) && window_resize_check (r, 0))
     {
       block_input ();
@@ -4245,8 +4252,15 @@
     {
       root = FRAME_ROOT_WINDOW (f);
       r = XWINDOW (root);
-      value = call2 (Qwindow_resize_root_window_vertically,
-		     root, make_number (size - 1));
+      if (WINDOW_LIVE_P (root))
+	{
+	  wset_new_total (r, make_number (XFASTINT (r->total_lines) + size - 1));
+	  value = make_number (size - 1);
+	}
+      else
+	value = call2 (Qwindow_resize_root_window_vertically,
+		       root, make_number (size - 1));
+
       if (INTEGERP (value) && window_resize_check (r, 0))
 	{
 	  block_input ();



--------------080307080307070907060905--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#13479; Package emacs. Full text available.

Message received at 13479 <at> debbugs.gnu.org:


Received: (at 13479) by debbugs.gnu.org; 19 Jan 2013 01:19:25 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Jan 18 20:19:25 2013
Received: from localhost ([127.0.0.1]:39327 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1TwN5h-0004E7-3C
	for submit <at> debbugs.gnu.org; Fri, 18 Jan 2013 20:19:25 -0500
Received: from ironport2-out.teksavvy.com ([206.248.154.182]:17952)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <monnier@HIDDEN>) id 1TwN5e-0004Dw-L4
	for 13479 <at> debbugs.gnu.org; Fri, 18 Jan 2013 20:19:23 -0500
X-IronPort-Anti-Spam-Filtered: true
X-IronPort-Anti-Spam-Result: AtkGAG6Zu09FpZpV/2dsb2JhbABEgXuyFoEIghUBAQQBViMFCws0EhQYDSSIHAW6CZBEA4hCmnGBWIMH
X-IronPort-AV: E=Sophos;i="4.75,637,1330923600"; d="scan'208";a="212937162"
Received: from 69-165-154-85.dsl.teksavvy.com (HELO fmsmemgm.homelinux.net)
	([69.165.154.85])
	by ironport2-out.teksavvy.com with ESMTP/TLS/ADH-AES256-SHA;
	18 Jan 2013 20:18:32 -0500
Received: by fmsmemgm.homelinux.net (Postfix, from userid 20848)
	id DDFEFAE071; Fri, 18 Jan 2013 20:18:31 -0500 (EST)
From: Stefan Monnier <monnier@HIDDEN>
To: martin rudalics <rudalics@HIDDEN>
Subject: Re: bug#13479: Cross Compiling for ARM
Message-ID: <jwvip6u9dle.fsf-monnier+emacs@HIDDEN>
References: <CAJ56fyho5sZoR2w15_h2KceCcqHf1=6-G=ocSQELCHS_2yF2dw@HIDDEN>
	<jwvsj5z9qph.fsf-monnier+emacs@HIDDEN> <50F98C7B.8090708@HIDDEN>
Date: Fri, 18 Jan 2013 20:18:31 -0500
In-Reply-To: <50F98C7B.8090708@HIDDEN> (martin rudalics's message of "Fri, 18
	Jan 2013 18:55:07 +0100")
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.3.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.8 (/)
X-Debbugs-Envelope-To: 13479
Cc: Ross Biro <ross.biro@HIDDEN>, 13479 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -0.5 (/)

>> Most/all calls to Elisp from C should protect themselves with calls to
>> Ffboundp or similar, indeed.  Martin, could you take care of that?
> I'm not sure.  If most/all calls should be protected we'd better provide
> call_[1-4]_safe function for this purpose.

Could be, but I suspect that when the function is not defined, we might
actually want to do something else rather than not do anything at all,
so maybe just call_safe is not quite sufficient.

> But I haven't the slightest idea of what might happen when some of
> these functions don't get called.

These calls come from your "rewrite" of the window.c code, AFAIK, so
I think you're the person who'd best know what needs to happen when
window.el is not yet loaded,


        Stefan




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#13479; Package emacs. Full text available.

Message received at 13479 <at> debbugs.gnu.org:


Received: (at 13479) by debbugs.gnu.org; 18 Jan 2013 22:10:31 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Jan 18 17:10:31 2013
Received: from localhost ([127.0.0.1]:39189 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1TwK8t-00088Y-5h
	for submit <at> debbugs.gnu.org; Fri, 18 Jan 2013 17:10:31 -0500
Received: from mail-la0-f48.google.com ([209.85.215.48]:49016)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <ross.biro@HIDDEN>) id 1TwK8q-00088P-8F
	for 13479 <at> debbugs.gnu.org; Fri, 18 Jan 2013 17:10:29 -0500
Received: by mail-la0-f48.google.com with SMTP id ej20so4406012lab.35
	for <13479 <at> debbugs.gnu.org>; Fri, 18 Jan 2013 14:09:38 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113;
	h=mime-version:x-received:sender:in-reply-to:references:date
	:x-google-sender-auth:message-id:subject:from:to:cc:content-type;
	bh=jIYC9jSdW6AISp31M7Zb5TdN4NVIynAwdu4QkyaAnFc=;
	b=X9fZD9X4KmwoUvP/W9ZD9j4z6XwCK+U5/hrZnOpSeK3bcXmdJ80fHhfJTJCSXxwyqN
	XXHxNvRP0rhAf0+F7XNQCdWVXfahU4ekKeXQ83o8iPVgKb05f9RTKtZjZ32Z9NK9pIZm
	w9iGsG0iTgztHsUFfr0WA7STE8zRyHpBgpEv+s3GUMUm9Xzb8Dedd7rcOVsdChuiupNk
	Nv3y/VqqbeQB2pNd33EYUV+RbAmkjwJyjFC+vpVNMxb0Akmk+rwyZ9g0/ghT4vvWlbwU
	CzFGquhlNfBqUCW03gGp/O6aRDCus9BoIjIZNyu/36jmEvsiWXT8d+viQ/BrDUIPhm9E
	bclQ==
MIME-Version: 1.0
X-Received: by 10.152.125.136 with SMTP id mq8mr9925313lab.41.1358546977196;
	Fri, 18 Jan 2013 14:09:37 -0800 (PST)
Received: by 10.152.11.169 with HTTP; Fri, 18 Jan 2013 14:09:36 -0800 (PST)
In-Reply-To: <50F98C7B.8090708@HIDDEN>
References: <CAJ56fyho5sZoR2w15_h2KceCcqHf1=6-G=ocSQELCHS_2yF2dw@HIDDEN>
	<jwvsj5z9qph.fsf-monnier+emacs@HIDDEN> <50F98C7B.8090708@HIDDEN>
Date: Fri, 18 Jan 2013 17:09:36 -0500
X-Google-Sender-Auth: zgPPU3RB-sbPN6PDw3nsUZrt4ic
Message-ID: <CAJ56fyiL62MtXUqD5PygCF3KUs-kJ5vmQ7S8bcBvn=fq21uMXg@HIDDEN>
Subject: Re: bug#13479: Cross Compiling for ARM
From: Ross Biro <ross.biro@HIDDEN>
To: martin rudalics <rudalics@HIDDEN>
Content-Type: multipart/alternative; boundary=f46d042f9756fc8b5d04d3975dac
X-Spam-Score: 0.1 (/)
X-Debbugs-Envelope-To: 13479
Cc: Stefan Monnier <monnier@HIDDEN>, 13479 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: 0.1 (/)

--f46d042f9756fc8b5d04d3975dac
Content-Type: text/plain; charset=ISO-8859-1

I haven't investigated.  But because protecting those calls by if
(initialized) and even moving the lisp->C binding for
window_root_window_resize_vertically to after initialization didn't help, I
suspect the issue might be deeper than just protecting C calls to lisp.  I
really don't know how to follow up though.

    Ross


On Fri, Jan 18, 2013 at 12:55 PM, martin rudalics <rudalics@HIDDEN> wrote:

> > Most/all calls to Elisp from C should protect themselves with calls to
> > Ffboundp or similar, indeed.  Martin, could you take care of that?
>
> I'm not sure.  If most/all calls should be protected we'd better provide
> call_[1-4]_safe function for this purpose.  But I haven't the slightest
> idea of what might happen when some of these functions don't get called.
>
> martin
>

--f46d042f9756fc8b5d04d3975dac
Content-Type: text/html; charset=ISO-8859-1
Content-Transfer-Encoding: quoted-printable

<div dir=3D"ltr"><div><div><br></div>I haven&#39;t investigated.=A0 But bec=
ause protecting those calls by if (initialized) and even moving the lisp-&g=
t;C binding for window_root_window_resize_vertically to after initializatio=
n didn&#39;t help, I suspect the issue might be deeper than just protecting=
 C calls to lisp.=A0 I really don&#39;t know how to follow up though.<br>
<br></div>=A0=A0=A0 Ross<br></div><div class=3D"gmail_extra"><br><br><div c=
lass=3D"gmail_quote">On Fri, Jan 18, 2013 at 12:55 PM, martin rudalics <spa=
n dir=3D"ltr">&lt;<a href=3D"mailto:rudalics@HIDDEN" target=3D"_blank">ruda=
lics@HIDDEN</a>&gt;</span> wrote:<br>
<blockquote class=3D"gmail_quote" style=3D"margin:0 0 0 .8ex;border-left:1p=
x #ccc solid;padding-left:1ex"><div class=3D"im">&gt; Most/all calls to Eli=
sp from C should protect themselves with calls to<br>
&gt; Ffboundp or similar, indeed. =A0Martin, could you take care of that?<b=
r>
<br></div>
I&#39;m not sure. =A0If most/all calls should be protected we&#39;d better =
provide<br>
call_[1-4]_safe function for this purpose. =A0But I haven&#39;t the slighte=
st<br>
idea of what might happen when some of these functions don&#39;t get called=
.<span class=3D"HOEnZb"><font color=3D"#888888"><br>
<br>
martin<br>
</font></span></blockquote></div><br></div>

--f46d042f9756fc8b5d04d3975dac--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#13479; Package emacs. Full text available.

Message received at 13479 <at> debbugs.gnu.org:


Received: (at 13479) by debbugs.gnu.org; 18 Jan 2013 17:56:06 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Jan 18 12:56:06 2013
Received: from localhost ([127.0.0.1]:39015 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1TwGAf-0001ny-DB
	for submit <at> debbugs.gnu.org; Fri, 18 Jan 2013 12:56:06 -0500
Received: from mout.gmx.net ([212.227.17.20]:58971)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <rudalics@HIDDEN>) id 1TwGAb-0001nW-OI
	for 13479 <at> debbugs.gnu.org; Fri, 18 Jan 2013 12:56:02 -0500
Received: from mailout-de.gmx.net ([10.1.76.4]) by mrigmx.server.lan
	(mrigmx001) with ESMTP (Nemesis) id 0MGlNX-1Tiq2K0BX7-00DWr3 for
	<13479 <at> debbugs.gnu.org>; Fri, 18 Jan 2013 18:55:13 +0100
Received: (qmail invoked by alias); 18 Jan 2013 17:55:12 -0000
Received: from 62-47-38-39.adsl.highway.telekom.at (EHLO [62.47.38.39])
	[62.47.38.39]
	by mail.gmx.net (mp004) with SMTP; 18 Jan 2013 18:55:12 +0100
X-Authenticated: #14592706
X-Provags-ID: V01U2FsdGVkX18i7QZhX34ixZMNayB9UODrYF2xPJpYBIM2yhSijd
	3hE6JtnkH5GY86
Message-ID: <50F98C7B.8090708@HIDDEN>
Date: Fri, 18 Jan 2013 18:55:07 +0100
From: martin rudalics <rudalics@HIDDEN>
MIME-Version: 1.0
To: Stefan Monnier <monnier@HIDDEN>
Subject: Re: bug#13479: Cross Compiling for ARM
References: <CAJ56fyho5sZoR2w15_h2KceCcqHf1=6-G=ocSQELCHS_2yF2dw@HIDDEN>
	<jwvsj5z9qph.fsf-monnier+emacs@HIDDEN>
In-Reply-To: <jwvsj5z9qph.fsf-monnier+emacs@HIDDEN>
Content-Type: text/plain; charset=ISO-8859-15; format=flowed
Content-Transfer-Encoding: 7bit
X-Y-GMX-Trusted: 0
X-Spam-Score: 0.8 (/)
X-Debbugs-Envelope-To: 13479
Cc: Ross Biro <ross.biro@HIDDEN>, 13479 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: 0.8 (/)

 > Most/all calls to Elisp from C should protect themselves with calls to
 > Ffboundp or similar, indeed.  Martin, could you take care of that?

I'm not sure.  If most/all calls should be protected we'd better provide
call_[1-4]_safe function for this purpose.  But I haven't the slightest
idea of what might happen when some of these functions don't get called.

martin




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#13479; Package emacs. Full text available.

Message received at 13479 <at> debbugs.gnu.org:


Received: (at 13479) by debbugs.gnu.org; 18 Jan 2013 14:27:43 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Jan 18 09:27:42 2013
Received: from localhost ([127.0.0.1]:38273 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1TwCuz-00046m-Ut
	for submit <at> debbugs.gnu.org; Fri, 18 Jan 2013 09:27:42 -0500
Received: from ironport2-out.teksavvy.com ([206.248.154.182]:10423)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <monnier@HIDDEN>) id 1TwCuv-00046c-JV
	for 13479 <at> debbugs.gnu.org; Fri, 18 Jan 2013 09:27:38 -0500
X-IronPort-Anti-Spam-Filtered: true
X-IronPort-Anti-Spam-Result: AtkGAG6Zu09FpZpV/2dsb2JhbABEgXuyFoEIghUBAQQBJy8jBQsLNBIUGA0kiBwFugmQRAOIQppxgViDBw
X-IronPort-AV: E=Sophos;i="4.75,637,1330923600"; d="scan'208";a="212864550"
Received: from 69-165-154-85.dsl.teksavvy.com (HELO pastel.home)
	([69.165.154.85])
	by ironport2-out.teksavvy.com with ESMTP/TLS/ADH-AES256-SHA;
	18 Jan 2013 09:26:49 -0500
Received: by pastel.home (Postfix, from userid 20848)
	id 8A4AA59550; Fri, 18 Jan 2013 09:26:49 -0500 (EST)
From: Stefan Monnier <monnier@HIDDEN>
To: Ross Biro <ross.biro@HIDDEN>
Subject: Re: bug#13479: Cross Compiling for ARM
Message-ID: <jwvsj5z9qph.fsf-monnier+emacs@HIDDEN>
References: <CAJ56fyho5sZoR2w15_h2KceCcqHf1=6-G=ocSQELCHS_2yF2dw@HIDDEN>
Date: Fri, 18 Jan 2013 09:26:49 -0500
In-Reply-To: <CAJ56fyho5sZoR2w15_h2KceCcqHf1=6-G=ocSQELCHS_2yF2dw@HIDDEN>
	(Ross Biro's message of "Thu, 17 Jan 2013 14:36:08 -0500")
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.3.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.8 (/)
X-Debbugs-Envelope-To: 13479
Cc: 13479 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -1.9 (-)

> Obviously, I also had to CANNOT_DUMP=yes as well.

That's a problem that would need to be solved, of course, because there
are invariably more bugs in this mode of operation.

> 1) It doesn't look like emacs has a concept of a BUILDCC.  I like to set CC
> to the cross compiler since that seems to be what most things need.
> However make-docfile and test-distrib need to be built with the local
> compiler.  Usually the path to the local compiler is stored in BUILDCC.
> I just changed the $(CC) to $(BUILDCC) in the makefile for those two file and
> everything compiled ok.

We could incorporate this part of your changes, I think.

> 2) The lisp and leim directories really want a local copy of Emacs to
> compile.

Actually, any random local copy probably won't cut it, it needs to be
sufficiently uptodate.  In the worst case, it needs to be exactly the
version you're compiling.

What would need to happen is to more clearly separate the
src/bootstrap-emacs (which should be built with BUILDCC) from the
src/emacs (built with CC), so that you can run the src/bootstrap-emacs
to compile the lisp and leim subdirectories.

An alternative is of course to use an emulator to run src/emacs and/or
src/bootstrap-emacs.

> 3) Now, a real bug.  With an undumpped emacs,
> window__resize_root_window_vertically is called before it's defined.  Even
> putting if (initialzed) before the call didn't help.  I had to put  if (!EQ
> (XSYMBOL (Qwindow_resize_root_window_vertically)->function, Qunbound))
> before the two calls to  call2 (Qwindow_resize_root_window_vertically,  in
> window.c.

Most/all calls to Elisp from C should protect themselves with calls to
Ffboundp or similar, indeed.  Martin, could you take care of that?


        Stefan




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#13479; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 17 Jan 2013 20:02:26 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Jan 17 15:02:26 2013
Received: from localhost ([127.0.0.1]:37370 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1TvvfN-0001r3-Io
	for submit <at> debbugs.gnu.org; Thu, 17 Jan 2013 15:02:26 -0500
Received: from eggs.gnu.org ([208.118.235.92]:36942)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <ross.biro@HIDDEN>) id 1TvvGr-0001Ff-FC
	for submit <at> debbugs.gnu.org; Thu, 17 Jan 2013 14:37:07 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
	(envelope-from <ross.biro@HIDDEN>) id 1TvvG6-00028r-99
	for submit <at> debbugs.gnu.org; Thu, 17 Jan 2013 14:36:23 -0500
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-2.6 required=5.0 tests=BAYES_00,FREEMAIL_FROM,
	HTML_MESSAGE,RCVD_IN_DNSWL_LOW,T_DKIM_INVALID autolearn=unavailable
	version=3.3.2
Received: from lists.gnu.org ([208.118.235.17]:32775)
	by eggs.gnu.org with esmtp (Exim 4.71)
	(envelope-from <ross.biro@HIDDEN>) id 1TvvG6-00028m-5l
	for submit <at> debbugs.gnu.org; Thu, 17 Jan 2013 14:36:18 -0500
Received: from eggs.gnu.org ([208.118.235.92]:48280)
	by lists.gnu.org with esmtp (Exim 4.71)
	(envelope-from <ross.biro@HIDDEN>) id 1TvvG2-0001XR-06
	for bug-gnu-emacs@HIDDEN; Thu, 17 Jan 2013 14:36:18 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
	(envelope-from <ross.biro@HIDDEN>) id 1TvvFx-000271-L4
	for bug-gnu-emacs@HIDDEN; Thu, 17 Jan 2013 14:36:13 -0500
Received: from mail-vc0-f170.google.com ([209.85.220.170]:36411)
	by eggs.gnu.org with esmtp (Exim 4.71)
	(envelope-from <ross.biro@HIDDEN>) id 1TvvFx-00026q-GF
	for bug-gnu-emacs@HIDDEN; Thu, 17 Jan 2013 14:36:09 -0500
Received: by mail-vc0-f170.google.com with SMTP id fl11so2953855vcb.29
	for <bug-gnu-emacs@HIDDEN>; Thu, 17 Jan 2013 11:36:08 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113;
	h=mime-version:x-received:sender:date:x-google-sender-auth:message-id
	:subject:from:to:content-type;
	bh=Cb/AgYjqHB4jhvoqnjF12EA+AjY/rQNET3yW3XdPl5I=;
	b=mCNsODBENczcoWRaNd6XEGIhVxWufPAND3VJiP9RFfh2vAojWrEsgJ9BMC6BJ+A/rv
	FAJsq2FIaQZGl6SPp1nbxJsGdG8daVpgNgdWS4+01u6tDJkkErINCk02WjKXRIKPQXmM
	8zX31fLTOp1vkceI4T6HVyEIGr25onUKcain0BRvtXPRFe5T5ubp41QG5VPVNfgaeRWC
	jbjVdwrGocwvPRdNRKuIE7U5vyMmhqPKhC1Ib5ci0Xtidd0hBfgzVvnkzBc5dh6qb55c
	yb0nZ4vuU+upRs8FB8dsUzCMZeuNJkhUuV9knFiUEasO4ynJfXiPjmr4CQuQWWv9w1S7
	v+8g==
MIME-Version: 1.0
X-Received: by 10.52.33.11 with SMTP id n11mr5882867vdi.131.1358451368402;
	Thu, 17 Jan 2013 11:36:08 -0800 (PST)
Received: by 10.58.106.167 with HTTP; Thu, 17 Jan 2013 11:36:08 -0800 (PST)
Date: Thu, 17 Jan 2013 14:36:08 -0500
X-Google-Sender-Auth: asbDirrJogtIl6wEbJ5YExlCNn0
Message-ID: <CAJ56fyho5sZoR2w15_h2KceCcqHf1=6-G=ocSQELCHS_2yF2dw@HIDDEN>
Subject: Cross Compiling for ARM
From: Ross Biro <ross.biro@HIDDEN>
To: bug-gnu-emacs@HIDDEN
Content-Type: multipart/alternative; boundary=20cf307c9d64421da004d3811b38
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 3.x [fuzzy]
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.6.x
X-Received-From: 208.118.235.17
X-Spam-Score: -3.4 (---)
X-Debbugs-Envelope-To: submit
X-Mailman-Approved-At: Thu, 17 Jan 2013 15:02:24 -0500
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -4.2 (----)

--20cf307c9d64421da004d3811b38
Content-Type: text/plain; charset=ISO-8859-1

I just more or less successfully compiled emacs-24.2 for a Samsung
Chromebook.  I did it by using the chrooted build environment for
chromiumos.  In the process I learned a couple of things.

I used the configuration:

../emacs-24.2/configure  --build=x86_64-pc-linux-gnu
--host=arm-none-linux-gnueabi --target=arm-none-linux-gnueabi
--with-x-toolkit=no --with-xpm=no --with-jpeg=no --with-png=no
--with-gif=no --with-tiff=no  --without-xml2 --without-gnutls --without-x
--without-dbus --with-crt-dir=/build/arm-generic/usr/lib/

Obviously, I also had to CANNOT_DUMP=yes as well.

1) It doesn't look like emacs has a concept of a BUILDCC.  I like to set CC
to the cross compiler since that seems to be what most things need.
However make-docfile and test-distrib need to be built with the local
compiler.  Usually the path to the local compiler is stored in BUILDCC.  I
just changed the $(CC) to $(BUILDCC) in the makefile for those two file and
everything compiled ok.

2) The lisp and leim directories really want a local copy of emacs to
compile.  Since I didn't have one available in the chrooted environment, I
just used /bin/true.  Suboptimal, but it let the compile complete.  I
didn't see an obvious way to set the path to an external emacs, I just
edited the makefile.

3) Now, a real bug.  With an undumpped emacs,
window__resize_root_window_vertically is called before it's defined.  Even
putting if (initialzed) before the call didn't help.  I had to put  if (!EQ
(XSYMBOL (Qwindow_resize_root_window_vertically)->function, Qunbound))
before the two calls to  call2 (Qwindow_resize_root_window_vertically,  in
window.c.

Now, I'm going to try to and some more libraries and do some additional
testing.  If anyone has questions, email me directly.

    Ross

--20cf307c9d64421da004d3811b38
Content-Type: text/html; charset=ISO-8859-1
Content-Transfer-Encoding: quoted-printable

<div dir=3D"ltr"><div><div><div><div><div><div><br></div>I just more or les=
s successfully compiled emacs-24.2 for a Samsung Chromebook.=A0 I did it by=
 using the chrooted build environment for chromiumos.=A0 In the process I l=
earned a couple of things.<br>
<br></div><div>I used the configuration:<br><br>../emacs-24.2/configure=A0 =
--build=3Dx86_64-pc-linux-gnu --host=3Darm-none-linux-gnueabi --target=3Dar=
m-none-linux-gnueabi --with-x-toolkit=3Dno --with-xpm=3Dno --with-jpeg=3Dno=
 --with-png=3Dno --with-gif=3Dno --with-tiff=3Dno=A0 --without-xml2 --witho=
ut-gnutls --without-x --without-dbus --with-crt-dir=3D/build/arm-generic/us=
r/lib/<br>
<br></div><div>Obviously, I also had to CANNOT_DUMP=3Dyes as well.<br></div=
><div><br></div>1) It doesn&#39;t look like emacs has a concept of a BUILDC=
C.=A0 I like to set CC to the cross compiler since that seems to be what mo=
st things need.=A0 However make-docfile and test-distrib need to be built w=
ith the local compiler.=A0 Usually the path to the local compiler is stored=
 in BUILDCC.=A0 I just changed the $(CC) to $(BUILDCC) in the makefile for =
those two file and everything compiled ok.<br>
<br></div>2) The lisp and leim directories really want a local copy of emac=
s to compile.=A0 Since I didn&#39;t have one available in the chrooted envi=
ronment, I just used /bin/true.=A0 Suboptimal, but it let the compile compl=
ete.=A0 I didn&#39;t see an obvious way to set the path to an external emac=
s, I just edited the makefile.<br>
<br></div>3) Now, a real bug.=A0 With an undumpped emacs, window__resize_ro=
ot_window_vertically is called before it&#39;s defined.=A0 Even putting if =
(initialzed) before the call didn&#39;t help.=A0 I had to put=A0 if (!EQ (X=
SYMBOL (Qwindow_resize_root_window_vertically)-&gt;function, Qunbound)) bef=
ore the two calls to=A0 call2 (Qwindow_resize_root_window_vertically,=A0 in=
 window.c.<br>
<br></div>Now, I&#39;m going to try to and some more libraries and do some =
additional testing.=A0 If anyone has questions, email me directly.<br><br><=
/div>=A0=A0=A0 Ross<br></div>

--20cf307c9d64421da004d3811b38--




Acknowledgement sent to Ross Biro <ross.biro@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-gnu-emacs@HIDDEN. Full text available.
Report forwarded to bug-gnu-emacs@HIDDEN:
bug#13479; Package emacs. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Fri, 31 Oct 2014 17:00:04 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.